# EAR E-shop

Sample project for EAR teaching in winter 2018. It is a simplified e-shop, concentrating on the backend part of the application. The following technologies are used/required
for development and running:

* JDK 8
* Apache Tomcat 9 or any Servlet API 4-compatible application server
* PostgreSQL 9 (a different database can be configured)
* Apache Maven 3.x

The application will eventually use:
* Spring 5
* Spring Security 5
* JPA 2.2
* Jackson 2.9
* Spring-based REST API
* JUnit 4, Mockito 2, Spring test, H2 database (for tests)
* SLF4J + Logback

### Frontend

Application front end is written is **React**. It exists only to provide a showcase for the implemented backend, 
i.e., so that you can see effects of the backend implementation. Since **you will not be learning frontend technologies in EAR 2018**, 
it is not necessary for you to understand how the UI works. The application uses a pre-build UI bundle, no action is necessary to 
get the UI working.

## Branches

The repository consists of several branches, where each topic has usually two branches - one with the problem you will be working on in the labs
and its solution. These branches will occur in the repository gradually, the "problem" one before the corresponding labs and the "solution" at the end of the
week of the corresponding labs. Your teachers will always tell you which branch to use.
